Index: branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1200)
@@ -1718,64 +1932,39 @@
 {
 
-#if H_3D_DISABLE_CHROMA
   Bool anyDepth = false; 
+#if NH_3D
   for ( Int i = 0; i < m_numberOfLayers; i++ )
   {
     vps.setVpsRepFormatIdx( i, m_depthFlag[ i ] ? 1 : 0 );
-    anyDepth = anyDepth || m_depthFlag[ i ]; 
-  }  
+    anyDepth = anyDepth || m_depthFlag[ i ];
+  }
+#endif
 
   vps.setRepFormatIdxPresentFlag( anyDepth ); 
-  vps.setVpsNumRepFormatsMinus1 ( anyDepth ? 1 : 0  ); 
-
+  vps.setVpsNumRepFormatsMinus1 ( anyDepth ? 1 : 0     ); 
+
+
+  std::vector<TComRepFormat> repFormat;
+  repFormat.resize( vps.getVpsNumRepFormatsMinus1() + 1 ); 
   for ( Int j = 0; j <= vps.getVpsNumRepFormatsMinus1(); j++ )
-  {
-    TComRepFormat* repFormat = new TComRepFormat; 
-
-    repFormat->setBitDepthVpsChromaMinus8   ( g_bitDepthC - 8 ); 
-    repFormat->setBitDepthVpsLumaMinus8     ( g_bitDepthY - 8 );
-    repFormat->setChromaFormatVpsIdc        ( j == 1 ? CHROMA_400 : CHROMA_420 );
-    repFormat->setPicHeightVpsInLumaSamples ( m_iSourceHeight );
-    repFormat->setPicWidthVpsInLumaSamples  ( m_iSourceWidth  );    
-    repFormat->setChromaAndBitDepthVpsPresentFlag( true );    
+  {           
+    repFormat[j].setBitDepthVpsChromaMinus8   ( m_internalBitDepth[CHANNEL_TYPE_LUMA  ] - 8 ); 
+    repFormat[j].setBitDepthVpsLumaMinus8     ( m_internalBitDepth[CHANNEL_TYPE_CHROMA] - 8 );
+    repFormat[j].setChromaFormatVpsIdc        ( j == 1 ? CHROMA_400 :  CHROMA_420 );
+    repFormat[j].setPicHeightVpsInLumaSamples ( m_iSourceHeight );
+    repFormat[j].setPicWidthVpsInLumaSamples  ( m_iSourceWidth  );    
+    repFormat[j].setChromaAndBitDepthVpsPresentFlag( true );    
     // ToDo not supported yet. 
     //repFormat->setSeparateColourPlaneVpsFlag( );
-    Bool conformanceWindowVpsFlag = ( m_confWinBottom != 0 ) || ( m_confWinRight != 0 ) || ( m_confWinTop != 0 ) || ( m_confWinBottom != 0 ); 
-    repFormat->setConformanceWindowVpsFlag( conformanceWindowVpsFlag );
-    if ( conformanceWindowVpsFlag ) 
-    {   
-      repFormat->setConfWinVpsLeftOffset    ( m_confWinLeft   / TComSPS::getWinUnitX( repFormat->getChromaFormatVpsIdc() ) );
-      repFormat->setConfWinVpsRightOffset   ( m_confWinRight  / TComSPS::getWinUnitX( repFormat->getChromaFormatVpsIdc() )  );
-      repFormat->setConfWinVpsTopOffset     ( m_confWinTop    / TComSPS::getWinUnitY( repFormat->getChromaFormatVpsIdc() )  );
-      repFormat->setConfWinVpsBottomOffset  ( m_confWinBottom / TComSPS::getWinUnitY( repFormat->getChromaFormatVpsIdc() ) ); 
-    }
-    assert( vps.getRepFormat( j ) == NULL ); 
-    vps.setRepFormat( j , repFormat );
-  }; 
-
-
-#else
-  vps.setRepFormatIdxPresentFlag( false ); 
-  vps.setVpsNumRepFormatsMinus1 ( 0    ); 
-
-  TComRepFormat* repFormat = new TComRepFormat; 
-
-  repFormat->setBitDepthVpsChromaMinus8   ( g_bitDepthC - 8 ); 
-  repFormat->setBitDepthVpsLumaMinus8     ( g_bitDepthY - 8 );
-  repFormat->setChromaFormatVpsIdc        ( CHROMA_420      );
-  repFormat->setPicHeightVpsInLumaSamples ( m_iSourceHeight );
-  repFormat->setPicWidthVpsInLumaSamples  ( m_iSourceWidth  );    
-  repFormat->setChromaAndBitDepthVpsPresentFlag( true );    
-  // ToDo not supported yet. 
-  //repFormat->setSeparateColourPlaneVpsFlag( );
-
-  repFormat->setConformanceWindowVpsFlag( true );
-  repFormat->setConfWinVpsLeftOffset    ( m_confWinLeft   / TComSPS::getWinUnitX( repFormat->getChromaFormatVpsIdc() ) );
-  repFormat->setConfWinVpsRightOffset   ( m_confWinRight  / TComSPS::getWinUnitX( repFormat->getChromaFormatVpsIdc() )  );
-  repFormat->setConfWinVpsTopOffset     ( m_confWinTop    / TComSPS::getWinUnitY( repFormat->getChromaFormatVpsIdc() )  );
-  repFormat->setConfWinVpsBottomOffset  ( m_confWinBottom / TComSPS::getWinUnitY( repFormat->getChromaFormatVpsIdc() ) ); 
-  assert( vps.getRepFormat( 0 ) == NULL ); 
-  vps.setRepFormat( 0 , repFormat );
-#endif
+
+    repFormat[j].setConformanceWindowVpsFlag( true );
+    repFormat[j].setConfWinVpsLeftOffset    ( m_confWinLeft   / TComSPS::getWinUnitX( repFormat[j].getChromaFormatVpsIdc() ) );
+    repFormat[j].setConfWinVpsRightOffset   ( m_confWinRight  / TComSPS::getWinUnitX( repFormat[j].getChromaFormatVpsIdc() )  );
+    repFormat[j].setConfWinVpsTopOffset     ( m_confWinTop    / TComSPS::getWinUnitY( repFormat[j].getChromaFormatVpsIdc() )  );
+    repFormat[j].setConfWinVpsBottomOffset  ( m_confWinBottom / TComSPS::getWinUnitY( repFormat[j].getChromaFormatVpsIdc() ) ); 
+  }
+
+  vps.setRepFormat( repFormat );
+
 }
 
@@ -1784,7 +1973,7 @@
   // These settings need to be verified
 
-  TComDpbSize* dpbSize = vps.getDpbSize(); 
-
-  assert ( dpbSize != 0 ); 
+  TComDpbSize dpbSize;   
+  dpbSize.init( vps.getNumOutputLayerSets(), vps.getVpsMaxLayerId() + 1, vps.getMaxSubLayersMinus1() + 1 ) ;
+  
 
   for( Int i = 0; i < vps.getNumOutputLayerSets(); i++ )
@@ -1801,8 +1990,8 @@
         if ( vps.getNecessaryLayerFlag( i,k ) && ( vps.getVpsBaseLayerInternalFlag() || vps.getLayerSetLayerIdList( currLsIdx, k ) != 0 ) )
         {       
-          dpbSize->setMaxVpsDecPicBufferingMinus1( i, k, j, m_maxDecPicBufferingMvc[ layerIdInVps ][ j ] - 1 );
+          dpbSize.setMaxVpsDecPicBufferingMinus1( i, k, j, m_maxDecPicBufferingMvc[ layerIdInVps ][ j ] - 1 );
           if ( j > 0 )
           {
-            subLayerDpbInfoPresentFlag = subLayerDpbInfoPresentFlag || ( dpbSize->getMaxVpsDecPicBufferingMinus1( i, k, j ) != dpbSize->getMaxVpsDecPicBufferingMinus1( i, k, j - 1 ) );
+            subLayerDpbInfoPresentFlag = subLayerDpbInfoPresentFlag || ( dpbSize.getMaxVpsDecPicBufferingMinus1( i, k, j ) != dpbSize.getMaxVpsDecPicBufferingMinus1( i, k, j - 1 ) );
           }
         }
@@ -1811,5 +2000,5 @@
           if (vps.getNecessaryLayerFlag(i,k) && j == 0 && k == 0 )
           {          
-            dpbSize->setMaxVpsDecPicBufferingMinus1(i, k ,j, 0 ); 
+            dpbSize.setMaxVpsDecPicBufferingMinus1(i, k ,j, 0 ); 
           }
         }
@@ -1827,25 +2016,26 @@
       assert( maxNumReorderPics != MIN_INT ); 
 
-      dpbSize->setMaxVpsNumReorderPics( i, j, maxNumReorderPics );
+      dpbSize.setMaxVpsNumReorderPics( i, j, maxNumReorderPics );
       if ( j > 0 )
       {
-        subLayerDpbInfoPresentFlag = subLayerDpbInfoPresentFlag || ( dpbSize->getMaxVpsNumReorderPics( i, j ) != dpbSize->getMaxVpsNumReorderPics( i, j - 1 ) );
+        subLayerDpbInfoPresentFlag = subLayerDpbInfoPresentFlag || ( dpbSize.getMaxVpsNumReorderPics( i, j ) != dpbSize.getMaxVpsNumReorderPics( i, j - 1 ) );
       }
 
       // To Be Done !
-      // dpbSize->setMaxVpsLatencyIncreasePlus1( i, j, xx );
+      // dpbSize.setMaxVpsLatencyIncreasePlus1( i, j, xx );
       if ( j > 0 )
       {
-        subLayerDpbInfoPresentFlag = subLayerDpbInfoPresentFlag || ( dpbSize->getMaxVpsLatencyIncreasePlus1( i, j ) != dpbSize->getMaxVpsLatencyIncreasePlus1( i, j - 1  ) );
+        subLayerDpbInfoPresentFlag = subLayerDpbInfoPresentFlag || ( dpbSize.getMaxVpsLatencyIncreasePlus1( i, j ) != dpbSize.getMaxVpsLatencyIncreasePlus1( i, j - 1  ) );
       }
 
       if( j > 0 )  
       {
-        dpbSize->setSubLayerDpbInfoPresentFlag( i, j, subLayerDpbInfoPresentFlag );
+        dpbSize.setSubLayerDpbInfoPresentFlag( i, j, subLayerDpbInfoPresentFlag );
         subLayerFlagInfoPresentFlag = subLayerFlagInfoPresentFlag || subLayerDpbInfoPresentFlag; 
       }       
     }  
-    dpbSize->setSubLayerFlagInfoPresentFlag( i, subLayerFlagInfoPresentFlag ); 
+    dpbSize.setSubLayerFlagInfoPresentFlag( i, subLayerFlagInfoPresentFlag ); 
   }  
+  vps.setDpbSize( dpbSize ); 
 }
 
@@ -2010,6 +2200,6 @@
   vps.setVpsVuiPresentFlag( m_vpsVuiPresentFlag ); 
 
-  TComVPSVUI* pcVPSVUI = vps.getVPSVUI(  ); 
-  assert( pcVPSVUI ); 
+  TComVPSVUI vpsVui;
+  vpsVui.init(vps.getNumAddLayerSets(),vps.getMaxSubLayersMinus1() + 1, vps.getMaxLayersMinus1() + 1 );
 
   if ( m_vpsVuiPresentFlag )
@@ -2018,11 +2208,11 @@
     // however preliminary setting it from input parameters
 
-    pcVPSVUI->setCrossLayerPicTypeAlignedFlag( m_crossLayerPicTypeAlignedFlag );
-    pcVPSVUI->setCrossLayerIrapAlignedFlag   ( m_crossLayerIrapAlignedFlag    );
-    pcVPSVUI->setAllLayersIdrAlignedFlag     ( m_allLayersIdrAlignedFlag      );
-    pcVPSVUI->setBitRatePresentVpsFlag( m_bitRatePresentVpsFlag );
-    pcVPSVUI->setPicRatePresentVpsFlag( m_picRatePresentVpsFlag );
-
-    if( pcVPSVUI->getBitRatePresentVpsFlag( )  ||  pcVPSVUI->getPicRatePresentVpsFlag( ) )
+    vpsVui.setCrossLayerPicTypeAlignedFlag( m_crossLayerPicTypeAlignedFlag );
+    vpsVui.setCrossLayerIrapAlignedFlag   ( m_crossLayerIrapAlignedFlag    );
+    vpsVui.setAllLayersIdrAlignedFlag     ( m_allLayersIdrAlignedFlag      );
+    vpsVui.setBitRatePresentVpsFlag( m_bitRatePresentVpsFlag );
+    vpsVui.setPicRatePresentVpsFlag( m_picRatePresentVpsFlag );
+
+    if( vpsVui.getBitRatePresentVpsFlag( )  ||  vpsVui.getPicRatePresentVpsFlag( ) )
     {
       for( Int i = 0; i  <  vps.getNumLayerSets(); i++ )
@@ -2030,27 +2220,27 @@
         for( Int j = 0; j  <=  vps.getMaxTLayers(); j++ ) 
         {
-          if( pcVPSVUI->getBitRatePresentVpsFlag( ) && m_bitRatePresentFlag[i].size() > j )
+          if( vpsVui.getBitRatePresentVpsFlag( ) && m_bitRatePresentFlag[i].size() > j )
           {
-            pcVPSVUI->setBitRatePresentFlag( i, j, m_bitRatePresentFlag[i][j] );            
+            vpsVui.setBitRatePresentFlag( i, j, m_bitRatePresentFlag[i][j] );            
           }
-          if( pcVPSVUI->getPicRatePresentVpsFlag( ) && m_picRatePresentFlag[i].size() > j   )
+          if( vpsVui.getPicRatePresentVpsFlag( ) && m_picRatePresentFlag[i].size() > j   )
           {
-            pcVPSVUI->setPicRatePresentFlag( i, j, m_picRatePresentFlag[i][j] );
+            vpsVui.setPicRatePresentFlag( i, j, m_picRatePresentFlag[i][j] );
           }
-          if( pcVPSVUI->getBitRatePresentFlag( i, j )  && m_avgBitRate[i].size() > j )
+          if( vpsVui.getBitRatePresentFlag( i, j )  && m_avgBitRate[i].size() > j )
           {
-            pcVPSVUI->setAvgBitRate( i, j, m_avgBitRate[i][j] );          
+            vpsVui.setAvgBitRate( i, j, m_avgBitRate[i][j] );          
           }
-          if( pcVPSVUI->getBitRatePresentFlag( i, j )  && m_maxBitRate[i].size() > j )
+          if( vpsVui.getBitRatePresentFlag( i, j )  && m_maxBitRate[i].size() > j )
           {
-            pcVPSVUI->setMaxBitRate( i, j, m_maxBitRate[i][j] );
+            vpsVui.setMaxBitRate( i, j, m_maxBitRate[i][j] );
           }
-          if( pcVPSVUI->getPicRatePresentFlag( i, j ) && m_constantPicRateIdc[i].size() > j )
+          if( vpsVui.getPicRatePresentFlag( i, j ) && m_constantPicRateIdc[i].size() > j )
           {
-            pcVPSVUI->setConstantPicRateIdc( i, j, m_constantPicRateIdc[i][j] );
+            vpsVui.setConstantPicRateIdc( i, j, m_constantPicRateIdc[i][j] );
           }
-          if( pcVPSVUI->getPicRatePresentFlag( i, j ) && m_avgPicRate[i].size() > j )
+          if( vpsVui.getPicRatePresentFlag( i, j ) && m_avgPicRate[i].size() > j )
           {
-            pcVPSVUI->setAvgPicRate( i, j, m_avgPicRate[i][j] );
+            vpsVui.setAvgPicRate( i, j, m_avgPicRate[i][j] );
           }
         }
@@ -2058,14 +2248,14 @@
     }
 
-    pcVPSVUI->setTilesNotInUseFlag( m_tilesNotInUseFlag );
-
-    if( !pcVPSVUI->getTilesNotInUseFlag() ) 
+    vpsVui.setTilesNotInUseFlag( m_tilesNotInUseFlag );
+
+    if( !vpsVui.getTilesNotInUseFlag() ) 
     {      
       for( Int i = 0; i  <=  vps.getMaxLayersMinus1(); i++ )
       {
-        pcVPSVUI->setTilesInUseFlag( i, m_tilesInUseFlag[ i ] );
-        if( pcVPSVUI->getTilesInUseFlag( i ) )  
+        vpsVui.setTilesInUseFlag( i, m_tilesInUseFlag[ i ] );
+        if( vpsVui.getTilesInUseFlag( i ) )  
         {
-          pcVPSVUI->setLoopFilterNotAcrossTilesFlag( i, m_loopFilterNotAcrossTilesFlag[ i ] );
+          vpsVui.setLoopFilterNotAcrossTilesFlag( i, m_loopFilterNotAcrossTilesFlag[ i ] );
         }
       }  
@@ -2076,7 +2266,7 @@
         {  
           Int layerIdx = vps.getLayerIdInVps( vps.getIdDirectRefLayer(vps.getLayerIdInNuh( i ) , j  ));  
-          if( pcVPSVUI->getTilesInUseFlag( i )  &&  pcVPSVUI->getTilesInUseFlag( layerIdx ) )  
+          if( vpsVui.getTilesInUseFlag( i )  &&  vpsVui.getTilesInUseFlag( layerIdx ) )  
           {
-            pcVPSVUI->setTileBoundariesAlignedFlag( i, j, m_tileBoundariesAlignedFlag[i][j] );
+            vpsVui.setTileBoundariesAlignedFlag( i, j, m_tileBoundariesAlignedFlag[i][j] );
           }
         }  
@@ -2084,20 +2274,20 @@
     }  
 
-    pcVPSVUI->setWppNotInUseFlag( m_wppNotInUseFlag );
-
-    if( !pcVPSVUI->getWppNotInUseFlag( ) )
+    vpsVui.setWppNotInUseFlag( m_wppNotInUseFlag );
+
+    if( !vpsVui.getWppNotInUseFlag( ) )
     {
       for( Int i = 1; i  <=  vps.getMaxLayersMinus1(); i++ )  
       {
-        pcVPSVUI->setWppInUseFlag( i, m_wppInUseFlag[ i ]);
-      }
-    }
-
-  pcVPSVUI->setSingleLayerForNonIrapFlag( m_singleLayerForNonIrapFlag );
-  pcVPSVUI->setHigherLayerIrapSkipFlag( m_higherLayerIrapSkipFlag );
-
-    pcVPSVUI->setIlpRestrictedRefLayersFlag( m_ilpRestrictedRefLayersFlag );
-
-    if( pcVPSVUI->getIlpRestrictedRefLayersFlag( ) )
+        vpsVui.setWppInUseFlag( i, m_wppInUseFlag[ i ]);
+      }
+    }
+
+  vpsVui.setSingleLayerForNonIrapFlag( m_singleLayerForNonIrapFlag );
+  vpsVui.setHigherLayerIrapSkipFlag( m_higherLayerIrapSkipFlag );
+
+    vpsVui.setIlpRestrictedRefLayersFlag( m_ilpRestrictedRefLayersFlag );
+
+    if( vpsVui.getIlpRestrictedRefLayersFlag( ) )
     {
       for( Int i = 1; i  <=  vps.getMaxLayersMinus1(); i++ )
@@ -2107,17 +2297,17 @@
           if ( m_minSpatialSegmentOffsetPlus1[i].size() > j )
           {        
-            pcVPSVUI->setMinSpatialSegmentOffsetPlus1( i, j, m_minSpatialSegmentOffsetPlus1[i][j] );
+            vpsVui.setMinSpatialSegmentOffsetPlus1( i, j, m_minSpatialSegmentOffsetPlus1[i][j] );
           }
-          if( pcVPSVUI->getMinSpatialSegmentOffsetPlus1( i, j ) > 0 )
+          if( vpsVui.getMinSpatialSegmentOffsetPlus1( i, j ) > 0 )
           {
             if ( m_ctuBasedOffsetEnabledFlag[i].size() > j )
             {        
-              pcVPSVUI->setCtuBasedOffsetEnabledFlag( i, j, m_ctuBasedOffsetEnabledFlag[i][j] );
+              vpsVui.setCtuBasedOffsetEnabledFlag( i, j, m_ctuBasedOffsetEnabledFlag[i][j] );
             }
-            if( pcVPSVUI->getCtuBasedOffsetEnabledFlag( i, j ) )
+            if( vpsVui.getCtuBasedOffsetEnabledFlag( i, j ) )
             {
               if ( m_minHorizontalCtuOffsetPlus1[i].size() > j )
               {
-                pcVPSVUI->setMinHorizontalCtuOffsetPlus1( i, j, m_minHorizontalCtuOffsetPlus1[i][j] );
+                vpsVui.setMinHorizontalCtuOffsetPlus1( i, j, m_minHorizontalCtuOffsetPlus1[i][j] );
               }
             }
@@ -2126,32 +2316,33 @@
       }
     }      
-    pcVPSVUI->setVideoSignalInfoIdxPresentFlag( true ); 
-    pcVPSVUI->setVpsNumVideoSignalInfoMinus1  ( 0    ); 
-
-    assert ( pcVPSVUI->getVideoSignalInfo( 0 ) == NULL );
-
-    TComVideoSignalInfo* videoSignalInfo = new TComVideoSignalInfo; 
-
-    videoSignalInfo->setColourPrimariesVps        ( m_colourPrimaries ); 
-    videoSignalInfo->setMatrixCoeffsVps           ( m_matrixCoefficients ); 
-    videoSignalInfo->setTransferCharacteristicsVps( m_transferCharacteristics ); 
-    videoSignalInfo->setVideoVpsFormat            ( m_videoFormat ); 
-    videoSignalInfo->setVideoFullRangeVpsFlag     ( m_videoFullRangeFlag );  
-
-    pcVPSVUI->setVideoSignalInfo( 0, videoSignalInfo );       
+    vpsVui.setVideoSignalInfoIdxPresentFlag( true ); 
+    vpsVui.setVpsNumVideoSignalInfoMinus1  ( 0    );     
+
+    std::vector<TComVideoSignalInfo> videoSignalInfos;
+    videoSignalInfos.resize( vpsVui.getVpsNumVideoSignalInfoMinus1() + 1 );
+
+    videoSignalInfos[0].setColourPrimariesVps        ( m_colourPrimaries ); 
+    videoSignalInfos[0].setMatrixCoeffsVps           ( m_matrixCoefficients ); 
+    videoSignalInfos[0].setTransferCharacteristicsVps( m_transferCharacteristics ); 
+    videoSignalInfos[0].setVideoVpsFormat            ( m_videoFormat ); 
+    videoSignalInfos[0].setVideoFullRangeVpsFlag     ( m_videoFullRangeFlag );  
+
+    vpsVui.setVideoSignalInfo( videoSignalInfos );       
 
     for (Int i = 0; i < m_numberOfLayers; i++)
     {      
-      pcVPSVUI->setVpsVideoSignalInfoIdx( i, 0 ); 
-    }
-    pcVPSVUI->setVpsVuiBspHrdPresentFlag( false ); // TBD
+      vpsVui.setVpsVideoSignalInfoIdx( i, 0 ); 
+    }
+    vpsVui.setVpsVuiBspHrdPresentFlag( false ); // TBD
   }
   else
   {
-    pcVPSVUI->setCrossLayerIrapAlignedFlag   ( false   );
-  }
-}
-
-#if H_3D
+    //Default inference when not present.
+    vpsVui.setCrossLayerIrapAlignedFlag   ( false   );
+  }
+  vps.setVPSVUI( vpsVui ); 
+}
+
+#if NH_3D
 Void TAppEncTop::xSetCamPara                ( TComVPS& vps )
 {
Index: branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncTop.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncTop.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncTop.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -46,5 +46,5 @@
 #include "TLibCommon/AccessUnit.h"
 #include "TAppEncCfg.h"
-#if H_3D
+#if NH_3D
 #include "../../Lib/TLibRenderer/TRenTop.h"
 #endif
@@ -65,15 +65,15 @@
 private:
   // class interface
-#if H_MV
+#if NH_MV
   std::vector<TEncTop*>      m_acTEncTopList ;              ///< encoder class per layer 
   std::vector<TVideoIOYuv*>  m_acTVideoIOYuvInputFileList;  ///< input YUV file
   std::vector<TVideoIOYuv*>  m_acTVideoIOYuvReconFileList;  ///< output reconstruction file
   
-  std::vector<TComList<TComPicYuv*>*>  m_picYuvRec;         ///< list of reconstruction YUV files
+  std::vector<TComList<TComPicYuv*>*>  m_cListPicYuvRec;         ///< list of reconstruction YUV files
 
   std::vector<Int>           m_frameRcvd;                   ///< number of received frames 
 
   TComPicLists               m_ivPicLists;                  ///< picture buffers of encoder instances
-#if H_MV
+#if NH_MV
   TComVPS*                   m_vps;                         ///< vps
 #else
@@ -84,7 +84,7 @@
   TVideoIOYuv                m_cTVideoIOYuvInputFile;       ///< input YUV file
   TVideoIOYuv                m_cTVideoIOYuvReconFile;       ///< output reconstruction file
-  
+
   TComList<TComPicYuv*>      m_cListPicYuvRec;              ///< list of reconstruction YUV files
-  
+
   Int                        m_iFrameRcvd;                  ///< number of received frames
 #endif
@@ -92,4 +92,6 @@
 #if H_3D
   TComDLT                    m_dlt;                         ///< dlt
+#endif
+#if NH_3D
   TComSps3dExtension         m_sps3dExtension;              ///< Currently all layers share the same sps 3D Extension  
 #endif
@@ -97,5 +99,5 @@
   UInt m_essentialBytes;
   UInt m_totalBytes;
-#if H_3D_VSO
+#if NH_3D_VSO
   TRenTop                     m_cRendererTop; 
   TRenModel                   m_cRendererModel;   
@@ -107,7 +109,7 @@
   Void  xInitLib          (Bool isFieldCoding);             ///< initialize encoder class
   Void  xDestroyLib       ();                               ///< destroy encoder class
-  
+
   /// obtain required buffers
-#if H_MV
+#if NH_MV
   Void  xGetBuffer(TComPicYuv*& rpcPicYuvRec, UInt layer);
 #else
@@ -117,15 +119,18 @@
   /// delete allocated buffers
   Void  xDeleteBuffer     ();
-  
+
   // file I/O
-#if H_MV
+#if NH_MV
   Void xWriteOutput(std::ostream& bitstreamFile, Int iNumEncoded, std::list<AccessUnit>& accessUnits, UInt layerId); ///< write bitstream to file
 #else
   Void xWriteOutput(std::ostream& bitstreamFile, Int iNumEncoded, const std::list<AccessUnit>& accessUnits); ///< write bitstream to file
 #endif
-  void rateStatsAccum(const AccessUnit& au, const std::vector<UInt>& stats);
-  void printRateSummary();
+  Void rateStatsAccum(const AccessUnit& au, const std::vector<UInt>& stats);
+  Void printRateSummary();
+  Void printChromaFormat();
 
-#if H_MV
+#if NH_MV
+  Void xSetTimingInfo             ( TComVPS& vps );
+  Void xSetHrdParameters          ( TComVPS& vps );
   Void xSetLayerIds               ( TComVPS& vps );  
   Void xSetDimensionIdAndLength   ( TComVPS& vps );
@@ -134,13 +139,13 @@
   Void xSetProfileTierLevel       ( TComVPS& vps );
 
-  Void xSetProfileTierLevel( TComVPS& vps, Int profileTierLevelIdx, Int subLayer,                              
-                             Profile::Name profile, Level::Name level, Level::Tier tier, 
-                             Bool progressiveSourceFlag, Bool interlacedSourceFlag, 
-                             Bool nonPackedConstraintFlag, Bool frameOnlyConstraintFlag, 
-                             Bool inbldFlag );
+  Void xSetProfileTierLevel       ( TComVPS& vps, Int profileTierLevelIdx, Int subLayer,                              
+                                    Profile::Name profile, Level::Name level, Level::Tier tier, 
+                                    Bool progressiveSourceFlag, Bool interlacedSourceFlag, 
+                                    Bool nonPackedConstraintFlag, Bool frameOnlyConstraintFlag, 
+                                    Bool inbldFlag );
   Void xSetRepFormat              ( TComVPS& vps );
   Void xSetDpbSize                ( TComVPS& vps );
   Void xSetVPSVUI                 ( TComVPS& vps );
-#if H_3D
+#if NH_3D
   Void xSetCamPara                ( TComVPS& vps );
 #endif
@@ -155,10 +160,11 @@
   Void  xAnalyzeInputBaseDepth(UInt layer, UInt uiNumFrames, TComVPS* vps, TComDLT* dlt);
 #endif
+
 public:
   TAppEncTop();
   virtual ~TAppEncTop();
-  
+
   Void        encode      ();                               ///< main encoding function
-#if H_MV
+#if NH_MV
   TEncTop*    getTEncTop( UInt layer ) { return  m_acTEncTopList[layer]; }  ///< return pointer to encoder class for specific layer
 #else
Index: branches/HTM-14.1-update-dev0/source/App/TAppEncoder/encmain.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppEncoder/encmain.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppEncoder/encmain.cpp	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -41,9 +41,8 @@
 #include "TAppCommon/program_options_lite.h"
 
-using namespace std;
-namespace po = df::program_options_lite;
-
 //! \ingroup TAppEncoder
 //! \{
+
+#include "../Lib/TLibCommon/Debug.h"
 
 // ====================================================================================================================
@@ -57,13 +56,13 @@
   // print information
   fprintf( stdout, "\n" );
-#if H_MV
+#if NH_MV
   fprintf( stdout, "3D-HTM Software: Encoder Version [%s] based on HM Version [%s]", NV_VERSION, HM_VERSION );  
 #else
-  fprintf( stdout, "HM software: Encoder Version [%s]", NV_VERSION );
+  fprintf( stdout, "HM software: Encoder Version [%s] (including RExt)", NV_VERSION );
 #endif
   fprintf( stdout, NVM_ONOS );
   fprintf( stdout, NVM_COMPILEDBY );
   fprintf( stdout, NVM_BITS );
-  fprintf( stdout, "\n" );
+  fprintf( stdout, "\n\n" );
 
   // create application encoder class
@@ -76,16 +75,27 @@
     {
       cTAppEncTop.destroy();
+#if ENVIRONMENT_VARIABLE_DEBUG_AND_TEST
+      EnvVar::printEnvVar();
+#endif
       return 1;
     }
   }
-  catch (po::ParseFailure& e)
+  catch (df::program_options_lite::ParseFailure &e)
   {
-    cerr << "Error parsing option \""<< e.arg <<"\" with argument \""<< e.val <<"\"." << endl;
+    std::cerr << "Error parsing option \""<< e.arg <<"\" with argument \""<< e.val <<"\"." << std::endl;
     return 1;
   }
 
+#if PRINT_MACRO_VALUES
+  printMacroSettings();
+#endif
+
+#if ENVIRONMENT_VARIABLE_DEBUG_AND_TEST
+  EnvVar::printEnvVarInUse();
+#endif
+
   // starting time
-  double dResult;
-  long lBefore = clock();
+  Double dResult;
+  clock_t lBefore = clock();
 
   // call encoding function
@@ -93,5 +103,5 @@
 
   // ending time
-  dResult = (double)(clock()-lBefore) / CLOCKS_PER_SEC;
+  dResult = (Double)(clock()-lBefore) / CLOCKS_PER_SEC;
   printf("\n Total Time: %12.3f sec.\n", dResult);
 
Index: branches/HTM-14.1-update-dev0/source/App/TAppExtractor/TAppExtrTop.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppExtractor/TAppExtrTop.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppExtractor/TAppExtrTop.cpp	(revision 1200)
@@ -42,5 +42,5 @@
 #include <assert.h>
 
-#if H_MV
+#if NH_MV
 // ====================================================================================================================
 // Constructor / destructor / initialization / destroy
@@ -49,7 +49,5 @@
 TAppExtrTop::TAppExtrTop()
 {
-  // To suppress compiler warnings on potential division by 0. 
-  g_uiMaxCUWidth  = 1;
-  g_uiMaxCUHeight = 1;
+
 }
 
@@ -110,5 +108,5 @@
     else
     {
-      read( nalu, nalUnit );
+      read( nalu );
 
       // decide whether to extract packet or not
Index: branches/HTM-14.1-update-dev0/source/App/TAppExtractor/TAppExtrTop.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppExtractor/TAppExtrTop.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppExtractor/TAppExtrTop.h	(revision 1200)
@@ -46,5 +46,5 @@
 #include "TAppExtrCfg.h"
 
-#if H_MV
+#if NH_MV
 // ====================================================================================================================
 // Class definition
Index: branches/HTM-14.1-update-dev0/source/App/TAppExtractor/extrmain.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppExtractor/extrmain.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppExtractor/extrmain.cpp	(revision 1200)
@@ -41,5 +41,5 @@
 #include "TAppExtrTop.h"
 
-#if H_MV
+#if NH_MV
 // ====================================================================================================================
 // Main function
@@ -82,5 +82,5 @@
 int main(int argc, char* argv[])
 {
-  std::cout << "Set H_MV equal to 1 in TypeDef.h to build bitstream extractor. " << std::endl; 
+  std::cout << "Set NH_MV equal to 1 in TypeDef.h to build bitstream extractor. " << std::endl; 
   return 1; 
 }
Index: branches/HTM-14.1-update-dev0/source/App/TAppRenderer/RendererMain.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppRenderer/RendererMain.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppRenderer/RendererMain.cpp	(revision 1200)
@@ -34,6 +34,6 @@
 
 #include <time.h>
-#include "../../Lib/TLibCommon/TypeDef.h"
-#if H_3D
+#include "../../Lib/TLibCommon/CommonDef.h"
+#if NH_3D
 #include "TAppRendererTop.h"
 // ====================================================================================================================
@@ -89,4 +89,4 @@
 }
 
-#endif // H_3D
+#endif // NH_3D
 
